const specialProps = new Map([
    ['class', 'className'],
    ['for', 'htmlFor'],
]);
const ɵ0 = x => (typeof x === 'function' && x.prototype && 'render' in x.prototype), ɵ1 = (x, props, children) => {
    return new x(Object.assign({}, props, { children })).render();
}, ɵ2 = x => x === Fragment, ɵ3 = (x, props, children) => {
    const fragment = document.createDocumentFragment();
    fragment.append(...children.flat());
    return fragment;
}, ɵ4 = x => typeof x === 'function', ɵ5 = (x, props, children) => {
    return x(Object.assign({}, props, { children }));
}, ɵ6 = x => typeof x === 'string', ɵ7 = (x, props, children) => {
    const element = document.createElement(x);
    for (let [name, value] of Object.entries(props || {})) {
        if (name.startsWith('on')) {
            name = name.toLowerCase();
        }
        else if (specialProps.has(name)) {
            name = specialProps.get(name); // tslint:disable-line:no-non-null-assertion
        }
        element[name] = value;
    }
    element.append(...children.flat());
    return element;
}, ɵ8 = x => { throw new Error(`Expected string, function or class, but given ${x}`); }, ɵ9 = () => undefined;
const elementFactories = [
    {
        match: ɵ0,
        get: ɵ1
    },
    {
        match: ɵ2,
        get: ɵ3,
    },
    {
        match: ɵ4,
        get: ɵ5
    },
    {
        match: ɵ6,
        get: ɵ7
    },
    {
        match: ɵ8,
        get: ɵ9,
    },
];
function createElement(name, props, ...children) {
    return elementFactories.find(({ match }) => match(name)) // tslint:disable-line:no-non-null-assertion
        .get(name, props, children);
}
function Fragment() {
}
const h = createElement;

export { Fragment, createElement, h, ɵ0, ɵ1, ɵ2, ɵ3, ɵ4, ɵ5, ɵ6, ɵ7, ɵ8, ɵ9 };
//# sourceMappingURL=h-document-element.js.map
